<template>
  <frame :modal="modal" position="bottom" dimmed>
    <headline>Enable Notifications</headline>
    <div class="px-8 max-w-xl">
      <div class="text-sm text-gray-600">
        You don't have notifications activated on this device. You will not receive any notifications you create. Do you
        want to activate them now?
      </div>
      <div class="bg-white flex flex-row items-center justify-between mt-8">
        <div>
          Notifications
          <div class="text-sm text-gray-500 font-light">
            <span v-if="Push.isDenied()">You denied Notifications in your browser</span>
            <span v-else-if="!Push.isSupported()">Push is not supported on this device</span>
            <span v-else-if="Push.isEnabled()">Push is enabled on this device</span>
            <span v-else>Push is not enabled on this device</span>
          </div>
        </div>
        <switch-box
          @click="Push.isAvailable() ? toggleNotifications() : null"
          :disabled="!Push.isAvailable()"
          :value="Push.isEnabled()"
          :loading="pushLoader.loading"
        />
      </div>
    </div>
    <actions class="mt-4">
      <cancel-action @click="modal.hide()">Close</cancel-action>
      <cancel-action @click="neverAskAgain()">Never ask again</cancel-action>
    </actions>
  </frame>
</template>

<script lang="ts">
import Frame from "@/use/modal/components/Frame.vue";
import Headline from "@/use/modal/components/Headline.vue";
import SwitchBox from "./SwitchBox.vue";
import { Push } from "@/assets/Push";
import { Loader } from "@/use/Loader";
import Actions from "@/use/modal/components/Actions.vue";
import CancelAction from "@/use/modal/components/CancelAction.vue";
import Setting from "@/models/Setting";

export default {
  components: { Frame, SwitchBox, Headline, Actions, CancelAction },
  props: {
    modal: { type: Object, required: true }
  },
  setup(props) {
    return {
      Push,
      pushLoader: new Loader(),
      neverAskAgain: () => {
        Setting.set("notificationHintShowed", true);
        props.modal.hide();
      }
    };
  }
};
</script>

<style></style>
